#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>



#include <gtk/gtk.h> 

#include <gmodule.h>




#include "nSX2.h"
#include "PS2Edefs.h"

_GSinit         GSinit;
_GSopen         GSopen;
_GSclose        GSclose;
_GSshutdown     GSshutdown;
_GSvsync        GSvsync;
_GSwrite32      GSwrite32;
_GSwrite64      GSwrite64;
_GSread32       GSread32;
_GSread64       GSread64;
_GSgifTransfer  GSgifTransfer;
_GSgifTransfer2 GSgifTransfer2;

_GSkeyEvent     GSkeyEvent;
_GSmakeSnapshot	GSmakeSnapshot;
_GSconfigure    GSconfigure;
_GStest         GStest;
_GSabout        GSabout;

void LoadGsPluggin( char * filename ) {

    GModule*  handle;
      
    gboolean   my_result ; 
    _u8         nbErrors=0;


    handle = g_module_open (filename,    G_MODULE_BIND_LAZY);

    if ( handle == NULL ) {
        printf("ERROR LOAD DLL\n");
        return;
    }
/*    
    my_result = g_module_symbol (handle, "_PS2EgetLibType", (gpointer*)&(_PS2EgetLibType));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "_PS2EgetLibVersion", (gpointer*)&(_PS2EgetLibVersion));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "_PS2EgetLibName", (gpointer*)&(_PS2EgetLibName));
    if ( my_result == FALSE ) nbErrors++;
*/
    my_result = g_module_symbol (handle, "GSinit", (gpointer*)&(GSinit));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSopen", (gpointer*)&(GSopen));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSclose", (gpointer*)&(GSclose));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSvsync", (gpointer*)&(GSvsync));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSshutdown", (gpointer*)&(GSshutdown));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSwrite32", (gpointer*)&(GSwrite32));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSwrite64", (gpointer*)&(GSwrite64));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSread32", (gpointer*)&(GSread32));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSread64", (gpointer*)&(GSread64));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSgifTransfer", (gpointer*)&(GSgifTransfer));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSgifTransfer2", (gpointer*)&(GSgifTransfer2));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSkeyEvent", (gpointer*)&(GSkeyEvent));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSmakeSnapshot", (gpointer*)&(GSmakeSnapshot));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSconfigure", (gpointer*)&(GSconfigure));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GStest", (gpointer*)&(GStest));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSabout", (gpointer*)&(GSabout));
    if ( my_result == FALSE ) nbErrors++;


}

