/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

void NOP		();

void SPECIAL	();
void REGIMM		();
void J			();
void JAL		(); 
void BEQ		(); 
void BNE		(); 
void BLEZ		(); 
void BGTZ		();
void ADDI		(); 
void ADDIU		(); 
void SLTI		(); 
void SLTIU		(); 
void ANDI		(); 
void ORI		(); 
void XORI		(); 
void LUI		();
void COP0		(); 
void COP1		(); 
void COP2		();

void BEQL		(); 
void BNEL		(); 
void BLEZL		(); 
void BGTZL		();
void DADDI		(); 
void DADDIU		(); 
void LDL		(); 
void LDR		(); 
void SPECIAL2	(); 

void LQ			();
void MDMX		(); 
void NI			();
void LB			(); 
void LH			(); 
void LWL		(); 
void LW			(); 
void LBU		(); 
void LHU		(); 
void LWR		(); 
void LWU		();
void SB			(); 
void SH			(); 
void SWL		(); 
void SW			(); 
void SDL		(); 
void SDR		(); 
void SWR		(); 
void CACHE		();

void LWC1		(); 

void PREF		(); 

 
void LQC2		(); 
void LD			();
 
void SWC1		(); 

void SQ			(); 


void SQC2		(); 
void SD			();


void SLL		(); 

void SRL		(); 
void SRA		(); 
void SLLV		(); 
void SRLV		(); 
void SRAV		();
void JR			(); 
void JALR		(); 
void MOVZ		(); 
void MOVN		(); 
void SYSCALL	(); 
void BREAK		(); 
void SYNC		();
void MFHI		(); 
void MTHI		(); 
void MFLO		(); 
void MTLO		(); 
void DSLLV		(); 
void DSRLV		(); 
void DSRAV		();
void MULT		(); 
void MULTU		(); 
void DIV		(); 
void DIVU		(); 

/*
void DMULT		(); 
void DMULTU		(); 
void DDIV		(); 
void DDIVU		();
*/
void ADD		(); 
void ADDU		(); 
void SUB		(); 
void SUBU		(); 
void AND		(); 
void OR			(); 
void XOR		(); 
void NOR		();
void MFSA		(); 
void MTSA		(); 
void SLT		(); 
void SLTU		(); 
void DADD		(); 
void DADDU		(); 
void DSUB		(); 
void DSUBU		();
void TGE		(); 
void TGEU		(); 
void TLT		(); 
void TLTU		(); 
void TEQ		(); 
void TNE		(); 
void DSLL		(); 
void DSRL		(); 
void DSRA		(); 
void DSLL32		(); 
void DSRL32		(); 
void DSRA32		();

void BLTZ(); 
void BGEZ(); 
void BLTZL   (); 
void BGEZL  (); 
void TGEI   (); 
void TGEIU (); 
void TLTI(); 
void TLTIU(); 
void TEQI(); 
void TNEI (); 
void BLTZAL   (); 
void BGEZAL  (); 
void BLTZALL  (); 
void BGEZALL  ();
void MTSAB  ();
void MTSAH  ();


void MF0  ();

void MT0  ();

void C0   ();
void BC0 ();

void TLBR(); 	
void TLBWI();
void TLBWR();	
void TLBP();		
void ERET(); 
	 

void EI(); 	
void DI(); 	
	  
void SYSCALL_RFU000_FullReset( );
void SYSCALL_ResetEE( );
void SYSCALL_SetGsCrt( );
void SYSCALL_RFU003( );
void SYSCALL_Exit( );
void SYSCALL_RFU005( );
void SYSCALL_LoadPS2Exe( );
void SYSCALL_ExecPS2( );
void SYSCALL_RFU008( );
void SYSCALL_RFU009( );
void SYSCALL_AddSbusIntcHandler( );
void SYSCALL_RemoveSbusIntcHandler( );
void SYSCALL_Interrupt2Iop( );
void SYSCALL_SetVTLBRefillHandler( );
void SYSCALL_SetVCommonHandler( );
void SYSCALL_SetVInterruptHandler( );
void SYSCALL_AddIntcHandler( );
void SYSCALL_RemoveIntcHandler( );
void SYSCALL_AddDmacHandler( );
void SYSCALL_RemoveDmacHandler( );
void SYSCALL__EnableIntc( );
void SYSCALL__DisableIntc( );
void SYSCALL__EnableDmac( );
void SYSCALL__DisableDmac( );
void SYSCALL__SetAlarm( );
void SYSCALL__ReleaseAlarm( );
void SYSCALL_NI( );
void SYSCALL_CreateThread( );
void SYSCALL_DeleteThread( );
void SYSCALL_StartThread( );
void SYSCALL_ExitThread( );
void SYSCALL_ExitDeleteThread( );
void SYSCALL_TerminateThread( );
void SYSCALL_DisableDispatchThread( );
void SYSCALL_EnableDispatchThread( );
void SYSCALL_ChangeThreadPriority( );
void SYSCALL_RotateThreadReadyQueue( );
void SYSCALL_ReleaseWaitThread( );
void SYSCALL_GetThreadId( );
void SYSCALL_ReferThreadStatus( );
void SYSCALL_SleepThread( );
void SYSCALL_WakeupThread( );
void SYSCALL_CancelWakeupThread( );
void SYSCALL_SuspendThread( );
void SYSCALL_ResumeThread( );
void SYSCALL_JoinThread( );
void SYSCALL_RFU060( );
void SYSCALL_RFU061( );
void SYSCALL_EndOfHeap( );
void SYSCALL_RFU063( );
void SYSCALL_CreateSema( );
void SYSCALL_DeleteSema( );
void SYSCALL_SignalSema( );
void SYSCALL_WaitSema( );
void SYSCALL_PollSema( );
void SYSCALL_ReferSemaStatus( );
void SYSCALL_RFU073( );
void SYSCALL_SetOsdConfigParam( );
void SYSCALL_GetOsdConfigParam( );
void SYSCALL_GetGsHParam( );
void SYSCALL_GetGsVParam( );
void SYSCALL_SetGsHParam( );
void SYSCALL_SetGsVParam( );
void SYSCALL_RFU080_CreateEventFlag( );
void SYSCALL_RFU081_DeleteEventFlag( );
void SYSCALL_RFU082_SetEventFlag( );
void SYSCALL_RFU083_iSetEventFlag( );
void SYSCALL_RFU084_ClearEventFlag( );
void SYSCALL_RFU085_iClearEventFlag( );
void SYSCALL_RFU086_WaitEvnetFlag( );
void SYSCALL_RFU087_PollEvnetFlag( );
void SYSCALL_RFU088_iPollEvnetFlag( );
void SYSCALL_RFU089_ReferEventFlagStatus( );
void SYSCALL_RFU091( );
void SYSCALL_EnableIntcHandler( );
void SYSCALL_DisableIntcHandler( );
void SYSCALL_EnableDmacHandler( );
void SYSCALL_DisableDmacHandler( );
void SYSCALL_KSeg0( );
void SYSCALL_EnableCache( );
void SYSCALL_DisableCache( );
void SYSCALL_GetCop0( );
void SYSCALL_FlushCache( );
void SYSCALL_CpuConfig( );
void SYSCALL_sceSifStopDma( );
void SYSCALL_SetCPUTimerHandler( );
void SYSCALL_SetCPUTimer( );
void SYSCALL_ForceRead( );
void SYSCALL_ForceWrite( );
void SYSCALL_GsGetIMR( );
void SYSCALL_GsPutIMR( );
void SYSCALL_SetPgifHandler( );
void SYSCALL_SetVSyncFlag( );
void SYSCALL_RFU116( );
void SYSCALL_print( );
void SYSCALL_sceSifDmaStat( );
void SYSCALL_sceSifSetDma( );
void SYSCALL_sceSifSetDChain( );
void SYSCALL_sceSifSetReg( );
void SYSCALL_sceSifGetReg( );
void SYSCALL_ExecOSD( );
void SYSCALL_Deci2Call( );
void SYSCALL_PSMode( );
void SYSCALL_MachineType( );
void SYSCALL_GetMemorySize( );
void SYSCALL_isceSifSetDChain( );
void SYSCALL_isceSifSetDma( );
void SYSCALL_isceSifDmaStat( );
void SYSCALL_iGsPutIMR( );
void SYSCALL_iGsGetIMR( );
void SYSCALL_iCpuConfig( );
void SYSCALL_iFlushCache( );
void SYSCALL_iGetCop0( );
void SYSCALL_iDisableDmacHandler( );
void SYSCALL_iEnableDmacHandler( );
void SYSCALL_iDisableIntcHandler( );
void SYSCALL_iEnableIntcHandler( );
void SYSCALL_RFU090_iReferEventFlagStatus( );
void SYSCALL_iReferSemaStatus( );
void SYSCALL_iPollSema( );
void SYSCALL_iSignalSema( );
void SYSCALL_iResumeThread( );
void SYSCALL_iSuspendThread( );
void SYSCALL_iCancelWakeupThread( );
void SYSCALL_iWakeupThread( );
void SYSCALL_iReferThreadStatus( );
void SYSCALL_iReleaseWaitThread( );
void SYSCALL_iRotateThreadReadyQueue( );
void SYSCALL_iChangeThreadPriority( );
void SYSCALL_iTerminateThread( );
void SYSCALL__iReleaseAlarm( );
void SYSCALL__iSetAlarm( );
void SYSCALL__iDisableDmac( );
void SYSCALL__iEnableDmac( );
void SYSCALL__iDisableIntc( );
void SYSCALL__iEnableIntc( );
void SYSCALL_UKN_1();

void MADD( );
		
void MADDU( );

void MULT1( );
void PLZCW( );
void MMI0 ();
void MMI2 ();
void MFHI1();
void MTHI1();
void MFLO1();
void MTLO1();

void MULTU1();
void DIV1();
void DIVU1();



void MADD1( );
void MADDU1( );

void MMI1( );
void MMI3( );

void PMFHL( );
void PMTHL( );
void PSLLH( );
void PSLLW( );

void PSRLH( );
void PSRAH( );
void PSRLW( );
void PSRAW( );



void MFC1( );
	
void CFC1( );			
void MTC1( );	

void CTC1( );	
void BC1( );	 		
void COP1_S( );
void COP1_D( );	
void COP1_W( );





	


void BC1F( ); 
void BC1T( );
void BC1FL( );
void BC1TL( );

void ADD_S( ); 		
void SUB_S( ); 		
void MUL_S( ); 		
void DIV_S( ); 		
void SQRT_S( ); 	
void ABS_S( ); 		
void MOV_S( ); 		
void NEG_S( );

void ADDA_S( );
void SUBA_S( );
void MULA_S( );

void MADD_S( );
void MSUB_S( );
void MADDA_S( );
void MSUBA_S( );





void RSQRT_S( );  	

void MAX_S( ); 
void MIN_S( ); 


		
void CVT_W_S( );	
	
void C_F_S( ); 		
	
void C_EQ_S( );		
	
void C_OLT_S( );	
	
void C_OLE_S( );	








void CVTS_W( );		
		


void MOVF_fmt( ); 
void MOVT_fmt( );	



/***************/


void pSPECIAL	();
void pREGIMM		();
void pJ			();
void pJAL		(); 
void pBEQ		(); 
void pBNE		(); 
void pBLEZ		(); 
void pBGTZ		();
void pADDI		(); 
void pADDIU		(); 
void pSLTI		(); 
void pSLTIU		(); 
void pANDI		(); 
void pORI		(); 
void pXORI		(); 
void pLUI		();
void pCOP0		(); 
void pCOP1		(); 
void pCOP2		();

void pBEQL		(); 
void pBNEL		(); 
void pBLEZL		(); 
void pBGTZL		();
void pDADDI		(); 
void pDADDIU		(); 
void pLDL		(); 
void pLDR		(); 
void pSPECIAL2	(); 

void pLQ			();
void pMDMX		(); 
void pNI			();
void pLB			(); 
void pLH			(); 
void pLWL		(); 
void pLW			(); 
void pLBU		(); 
void pLHU		(); 
void pLWR		(); 
void pLWU		();
void pSB			(); 
void pSH			(); 
void pSWL		(); 
void pSW			(); 
void pSDL		(); 
void pSDR		(); 
void pSWR		(); 
void pCACHE		();

void pLWC1		(); 

void pPREF		(); 

 
void pLQC2		(); 
void pLD			();
 
void pSWC1		(); 

void pSQ			(); 


void pSQC2		(); 
void pSD			();


void pSLL		(); 

void pSRL		(); 
void pSRA		(); 
void pSLLV		(); 
void pSRLV		(); 
void pSRAV		();
void pJR			(); 
void pJALR		(); 
void pMOVZ		(); 
void pMOVN		(); 
void pSYSCALL	(); 
void pBREAK		(); 
void pSYNC		();
void pMFHI		(); 
void pMTHI		(); 
void pMFLO		(); 
void pMTLO		(); 
void pDSLLV		(); 
void pDSRLV		(); 
void pDSRAV		();
void pMULT		(); 
void pMULTU		(); 
void pDIV		(); 
void pDIVU		(); 

/*
void DMULT		(); 
void DMULTU		(); 
void DDIV		(); 
void DDIVU		();
*/
void pADD		(); 
void pADDU		(); 
void pSUB		(); 
void pSUBU		(); 
void pAND		(); 
void pOR			(); 
void pXOR		(); 
void pNOR		();
void pMFSA		(); 
void pMTSA		(); 
void pSLT		(); 
void pSLTU		(); 
void pDADD		(); 
void pDADDU		(); 
void pDSUB		(); 
void pDSUBU		();
void pTGE		(); 
void pTGEU		(); 
void pTLT		(); 
void pTLTU		(); 
void pTEQ		(); 
void pTNE		(); 
void pDSLL		(); 
void pDSRL		(); 
void pDSRA		(); 
void pDSLL32		(); 
void pDSRL32		(); 
void pDSRA32		();

void pBLTZ(); 
void pBGEZ(); 
void pBLTZL   (); 
void pBGEZL  (); 
void pTGEI   (); 
void pTGEIU (); 
void pTLTI(); 
void pTLTIU(); 
void pTEQI(); 
void pTNEI (); 
void pBLTZAL   (); 
void pBGEZAL  (); 
void pBLTZALL  (); 
void pBGEZALL  ();
void pMTSAB  ();
void pMTSAH  ();


void pMF0  ();

void pMT0  ();

void pC0   ();
void pBC0 ();

void pTLBR(); 	
void pTLBWI();
void pTLBWR();	
void pTLBP();		
void pERET(); 
	 

void pEI(); 	
void pDI(); 	
	  


void pMADD( );
		
void pMADDU( );

void pMULT1( );
void pPLZCW( );
void pMMI0 ();
void pMMI2 ();
void pMFHI1();
void pMTHI1();
void pMFLO1();
void pMTLO1();

void pMULTU1();
void pDIV1();
void pDIVU1();



void pMADD1( );
void pMADDU1( );

void pMMI1( );
void pMMI3( );

void pPMFHL( );
void pPMTHL( );
void pPSLLH( );
void pPSLLW( );

void pPSRLH( );
void pPSRAH( );
void pPSRLW( );
void pPSRAW( );



void pMFC1( );
	
void pCFC1( );			
void pMTC1( );	

void pCTC1( );	
void pBC1( );	 		
void pCOP1_S( );
void pCOP1_D( );	
void pCOP1_W( );





	


void pBC1F( ); 
void pBC1T( );
void pBC1FL( );
void pBC1TL( );

void pADD_S( ); 		
void pSUB_S( ); 		
void pMUL_S( ); 		
void pDIV_S( ); 		
void pSQRT_S( ); 	
void pABS_S( ); 		
void pMOV_S( ); 		
void pNEG_S( );

void pADDA_S( );
void pSUBA_S( );
void pMULA_S( );

void pMADD_S( );
void pMSUB_S( );
void pMADDA_S( );
void pMSUBA_S( );





void pRSQRT_S( );  	

void pMAX_S( ); 
void pMIN_S( ); 


		
void pCVT_W_S( );	
	
void pC_F_S( ); 		
	
void pC_EQ_S( );		
	
void pC_OLT_S( );	
	
void pC_OLE_S( );	








void pCVTS_W( );		
		


void pMOVF_fmt( ); 
void pMOVT_fmt( );	




